diff -r -N -c -b -B cosmomc/source/CMB_Cls_simple.f90 cosmomc_addon/source/CMB_Cls_simple.f90
*** cosmomc/source/CMB_Cls_simple.f90	2006-03-17 16:18:11.000000000 +0000
--- cosmomc_addon/source/CMB_Cls_simple.f90	2006-04-04 10:34:35.000000000 +0100
***************
*** 266,271 ****
--- 266,289 ----
     type(CAMBParams)  P 
     integer zix
  
+ !addon
+    AccuracyBoost = AccuracyLevel
+    lAccuracyBoost = lAccuracyLevel
+    lSampleBoost = lSampleLevel
+    ComputeEveryl = CambComputeEveryl
+ 
+    write(*,*)
+    write(*,*) '>>>>>>>>>>>>>> accuracy settings <<<<<<<<<<<<<<'
+    write(*,*) 'Power_Name     =    ',Power_Name
+    write(*,*) 'write_all_cls  =   ',write_all_cls
+    write(*,*) 'AccuracyBoost  = ',AccuracyBoost
+    write(*,*) 'lAccuracyBoost = ',lAccuracyBoost          
+    write(*,*) 'DoClsInterpol  =   ',DoClsInterpol
+    write(*,*) 'ComputeEveryl  =   ',ComputeEveryl
+    write(*,*) '>>>>>>>>>>>>>> accuracy settings <<<<<<<<<<<<<<'
+    write(*,*)
+ !end addon
+ 
          Threadnum =num_threads
          w_lam = -1
          call CAMB_SetDefParams(P)
***************
*** 294,302 ****
              P%Transfer%high_precision=.true.
              P%Transfer%k_per_logint=3*nint(AccuracyLevel)
            end if
!           AccuracyBoost = AccuracyLevel
!           lAccuracyBoost = AccuracyLevel
!           lSampleBoost = AccuracyLevel
            P%AccurateReionization = .true.
          end if
                  
--- 312,323 ----
              P%Transfer%high_precision=.true.
              P%Transfer%k_per_logint=3*nint(AccuracyLevel)
            end if
! !addon
! !moved up for screen output
! !          AccuracyBoost = AccuracyLevel
! !          lAccuracyBoost = AccuracyLevel
! !          lSampleBoost = AccuracyLevel
! !end addon
            P%AccurateReionization = .true.
          end if
                  
diff -r -N -c -b -B cosmomc/source/driver.F90 cosmomc_addon/source/driver.F90
*** cosmomc/source/driver.F90	2006-03-17 21:11:02.000000000 +0000
--- cosmomc_addon/source/driver.F90	2006-04-04 10:34:35.000000000 +0100
***************
*** 50,61 ****
  
  #ifdef MPI 
  
!         if (instance /= 0) call DoStop('With MPI should not have second parameter')
          call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
  
  
          instance = MPIrank +1 !start at 1 for chains                                             
!         write (numstr,*) instance
          rand_inst = instance
          if (ierror/=MPI_SUCCESS) call DoStop('MPI fail')
  
--- 50,69 ----
  
  #ifdef MPI 
  
! !addon
! !        if (instance /= 0) call DoStop('With MPI should not have second parameter')
!         instance_shift=instance
!         write(*,*)'MPI file names shifted by: ',instance_shift
! !end addon
          call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
  
  
          instance = MPIrank +1 !start at 1 for chains                                             
! !addon
! !        write (numstr,*) instance
!         instance_shift = MPIrank + instance_shift
!         write (numstr,*) instance_shift
! !end addon
          rand_inst = instance
          if (ierror/=MPI_SUCCESS) call DoStop('MPI fail')
  
***************
*** 77,82 ****
--- 85,95 ----
  
          propose_scale = Ini_Read_Real('propose_scale',2.4)
          AccuracyLevel = Ini_Read_Real('accuracy_level',1.)
+ !addon
+         lAccuracyLevel = Ini_Read_Real('l_accuracy_level',1.)
+         lSampleLevel = Ini_Read_Real('l_sample_level',1.)
+         CambComputeEveryl = Ini_Read_Logical('camb_compute_every_l',.false.)
+ !end addon
  
          checkpoint = Ini_Read_Logical('checkpoint',.false.)
          if (checkpoint) flush_write = .true.
diff -r -N -c -b -B cosmomc/source/GetDist.f90 cosmomc_addon/source/GetDist.f90
*** cosmomc/source/GetDist.f90	2006-04-02 23:49:21.000000000 +0100
--- cosmomc_addon/source/GetDist.f90	2006-04-04 10:34:35.000000000 +0100
***************
*** 67,72 ****
--- 67,75 ----
          logical force_twotail 
          logical smoothing, plot_meanlikes, plot_NDcontours
          logical shade_meanlikes, make_single_samples
+ !addon
+         logical td_meanlikes
+ !end addon
          integer single_thin,cust2DPlots(max_cols**2)
          integer ix_min(max_cols),ix_max(max_cols)
          real center(max_cols),width(max_cols)   
***************
*** 1146,1160 ****
   !             write (aunit,fmt) (/(I, I=ix_min(j), ix_max(j), 1)/)*width(j)+center(j)
                if (DoShade) then
                if (shade_meanlikes) then
                  write (aunit,'(a)') 'load (fullfile(''plot_data'',''' // trim(plotfile) //'_likes''));'
                  write (aunit,*) 'contourf(x1,x2,'//trim(plotfile)//'_likes,64);'
                else     
                  write (aunit,*) 'contourf(x1,x2,pts,64);'
                end if
! 
                write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
!               end if
!               
             
                if (num_contours /= 0) then
  
--- 1149,1176 ----
   !             write (aunit,fmt) (/(I, I=ix_min(j), ix_max(j), 1)/)*width(j)+center(j)
                if (DoShade) then
                if (shade_meanlikes) then
+ !addon
                  write (aunit,'(a)') 'load (fullfile(''plot_data'',''' // trim(plotfile) //'_likes''));'
+                  if (td_meanlikes) then
+                     write (aunit,*) 'surfl(x1,x2,'//trim(plotfile)//'_likes);'
+                  else
                  write (aunit,*) 'contourf(x1,x2,'//trim(plotfile)//'_likes,64);'
+                  endif
+ !end addon
                else     
                  write (aunit,*) 'contourf(x1,x2,pts,64);'
                end if
! !addon
! !              write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
!               if (td_meanlikes) then
!                  write (aunit,*) 'set(gca,''climmode'',''manual'');shading interp; hold on;'
!                  write (aunit,*) 'grid off;box on;camproj(''perspective'');'
!                  write (aunit,*) 'set(gca,''climmode'',''manual'');alpha(0.9);axis tight'
!               else
                write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
!               endif
! !end addon
!               endif
             
                if (num_contours /= 0) then
  
***************
*** 1449,1454 ****
--- 1465,1473 ----
            write (*,*) 'WARNING: Mapping params - .covmat file is new params.'
  
      shade_meanlikes = Ini_Read_Logical('shade_meanlikes',.false.)   
+ !addon
+     td_meanlikes = Ini_Read_Logical('td_meanlikes',.false.)  
+ !end addon
  
      matlab_col = Ini_Read_String('matlab_colscheme')
      smoothing = Ini_Read_Logical('smoothing',.true.)
***************
*** 1955,1961 ****
--- 1974,1987 ----
                write (51,*)  'set(gcf, ''PaperUnits'',''inches'');'
       
                if (plot_row < plot_col .and. plot_row*plot_col>9) then
+ !addon
+ !            write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 10]);';
+          if (td_meanlikes) then
+             write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 7 9]);';
+          else
                  write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 10]);';
+          endif
+ !end addon           
                else
                  write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 8]);';
                end if
diff -r -N -c -b -B cosmomc/source/Makefile cosmomc_addon/source/Makefile
*** cosmomc/source/Makefile	2006-04-03 13:37:37.000000000 +0100
--- cosmomc_addon/source/Makefile	2006-04-04 10:35:03.000000000 +0100
***************
*** 1,160 ****
! #Settings here are for Intel ifort on CITA cluster; uncomment others below
! #You may need to edit the library paths for MKL for Intel
! #Beware of using optmizations which lose accuracy - may give errors when running
! #With Visual Fortan open cosmomc.dsw workspace file instead.
! 
! #Edit for CFITSIO, HEALPIX directories
! cfitsio = /home/pascal/include/cfitsio
! healpix = /home/pascal/include/Healpix_2.00
! WMAP3 = /home/antlewis/WMAP3
! 
! #Intel MPI (assuming mpif77 set to point to ifc)
! #change -lmkl_ia32 to -lmkl_p3 for MKL versions earlier than 6 (6 needed for ifc 8+) 
! F90C     = mpif77
! FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp -DMPI
! LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
! INCLUDE = -I../camb 
  
! # Use with Intel 9 on the Altix (eg. COSMOS)
! # (do "module load icomp90" before compiling, or add to .bashrc)
! #F90C = ifort
! #FFLAGS = -O3 -w -fpp2 -DMPI 
! #LAPACKL = -lscs -lguide -lmpi -ldl
! #INCLUDE = -I../camb
! 
! #Intel fortran 8, check you have the latest update from the Intel web pages
! #See Makefile_intel for ifc 7.1 or lower (some versions have problems)
! #F90C     = ifort
! #FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp
! #LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
! #INCLUDE = -I../camb 
! 
! #Intel fortran 8 on COSMOS
! #F90C     = ifort
! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp2 -lmpi -lscs  -ldl -DMPI
! #LAPACKL = -L/opt/intel/mkl80/lib/64 -lmkl_lapack -lmkl_ipf -limf
! #INCLUDE = -I../camb
! 
! #SGI, -mp toggles multi-processor. Use -O2 if -Ofast gives problems.
! #Not various versions of the compiler are buggy giving erroneous seg faults with -mp.
! #Version 7.3 is OK, currently version 7.4 is bugged, as are some earlier versions.
! #F90C     = f90
  #LAPACKL = -lcomplib.sgimath
! #INCLUDE = -I../camb 
! #FFLAGS  = -Ofast -mp
  
! #Digital/Compaq fortran, -omp toggles multi-processor
! #F90C    = f90
! #FFLAGS  = -omp -O4 -arch host -math_library fast -tune host -fpe1
! #LAPACKL  = -lcxml
! #INCLUDE = -I../camb 
! 
! #Intel Itanium efc, -openmp toggles multi-processor:
! #F90C     = efc
! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp
! #LAPACKL = -L/opt/intel/mkl/lib/64 -lmkl_lapack -lmkl_ipf -lguide -lpthread -static
! #INCLUDE = -I../camb 
! 
! #Intel Itanium efc MPI:
! # mpirun -np 4 ./cosmomc params.ini
! #F90C     = efc
! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp -lmpi -lscs  -ldl -DMPI
! #LAPACKL = -L/opt/intel/mkl/lib/64 -lmkl_lapack -lmkl_ipf -limf
! #INCLUDE = -I../camb
! 
! #G95; make sure LAPACK and MPI libs also compiled with g95
! #F90C     = mpif90
! #FFLAGS = -O2 -DMPI
! #LAPACKL = /LAPACK/lapack_LINUX.a /LAPACK/blas_LINUX.a
! #INCLUDE = -I../camb
! 
! #Absoft ProFortran, single processor, set -cpu:[type] for your local system 
! #F90C     = f95
! #FFLAGS = -O2 -s -cpu:athlon -lU77 -w -YEXT_NAMES="LCS" -YEXT_SFX="_" 
! #LAPACKL =  -llapack -lblas -lg2c 
! #INCLUDE = -I../camb -p../camb
! 
! #NAGF95, single processor:
! #F90C     = f95
! #FFLAGS = -DNAGF95 -O3
! #LAPACKL = -llapack -lblas -lg2c
! #INCLUDE = -I../camb 
! 
! #Sun, single processor:
! #F90C     = f90
! #FFLAGS = -O5
! #LAPACKL = -lsunperf -lfsu
! #INCLUDE = -I../camb -M../camb
! 
! #Sun MPI
! #F90C = mpf90
! #FFLAGS =  -O4 -openmp -ftrap=%none -dalign -DMPI
! #LAPACKL = -lsunperf -lfsu -lmpi_mt
! #INCLUDE = -I../camb -M../camb
! 
! #Sun parallel enterprise:
! #F90C     = f95
! #FFLAGS =  -O4 -xarch=native64 -openmp -ftrap=%none
! #LAPACKL = -lsunperf -lfsu
! #INCLUDE = -I../camb -M../camb
! 
! #IBM XL Fortran, multi-processor (run "module load lapack" then run "gmake")
! # See also http://cosmocoffee.info/viewtopic.php?t=326
! #F90C     = xlf90_r $(LAPACK)
! #FFLAGS  = -WF,-DIBMXL -qsmp=omp -qsuffix=f=f90:cpp=F90 -O3 -qstrict -qarch=pwr3 -qtune=pwr3
! #INCLUDE = -I../camb -lessl
! #LAPACKL =
  
  PROPOSE = propose.o
  CLSFILE = CMB_Cls_simple.o
  
  #Can use params_H if you prefer more generic parameters
  PARAMETERIZATION = params_CMB.o
  
! WMAP3_inc = -I$(cfitsio)/include -I$(healpix)/include -I$(WMAP3)
! WMAP3_lib = -L$(cfitsio)/lib -L$(healpix)/lib -L$(WMAP3) \
! 	-lhealpix -lcfitsio
  
! CLSLIB  = $(WMAP3_lib) -L../camb -lcamb $(LAPACKL) 
  
! F90FLAGS = $(FFLAGS) $(WMAP3_inc) $(INCLUDE)
  
  DISTFILES = utils.o settings.o GetDist.o
  
! WMAPOBJS = $(WMAP3)/read_archive_map.o \
! 	$(WMAP3)/read_fits.o \
! 	$(WMAP3)/WMAP_3yr_options.o \
! 	$(WMAP3)/WMAP_3yr_util.o \
! 	$(WMAP3)/WMAP_3yr_tt_pixlike.o \
! 	$(WMAP3)/WMAP_3yr_tt_beam_and_ptsrc_corr.o \
! 	$(WMAP3)/WMAP_3yr_teeebb_pixlike.o \
! 	$(WMAP3)/WMAP_3yr_likelihood.o
  
  OBJFILES= $(WMAPOBJS) utils.o settings.o cmbtypes.o cmbdata.o WeakLen.o twodf.o mpk.o \
! 	supernovae.o SDSSLy-a-v3.o\
  	$(CLSFILE) paramdef.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
  	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
  
! default: cosmomc
  
! all : cosmomc getdist
  
  .f.o:
  	f77 $(F90FLAGS) -c $<
  
  %.o: %.f90
! 	$(F90C) $(F90FLAGS) -c $*.f90
  
  %.o: %.F90
! 	$(F90C) $(F90FLAGS) -c $*.F90
! 
  
- cosmomc: $(OBJFILES) 	
- 	$(F90C) -o ../cosmomc $(OBJFILES) $(CLSLIB) $(F90FLAGS)
  
  
  clean:
  	rm -f *.o *.mod *.d *.pc *.obj ../core
  
! getdist: $(DISTFILES)
! 	$(F90C) -o ../getdist $(DISTFILES) $(CLSLIB) $(F90FLAGS) 
--- 1,103 ----
! # >>> DESIGNED FOR GMAKE <<<
! 
! # Unified Systems makefile for COSMOMC
! # Add FLAGS -DMPI for using MPI
  
! ext=$(shell uname | cut -c1-3)
! 
! ifeq ($(ext),IRI)
! F90C= f90
! FFLAGS= -Ofast -mp -n32 -LANG:recursive=ON -lmpi -DMPI
! WMAPFLAGS= $(FFLAGS)
  #LAPACKL = -lcomplib.sgimath
! LAPACKL = -lcomplib.sgimath_mp
! INCLUDE = -I../camb
! CFITSIODIR = /people/ringeval/usr
! HEALPIXDIR = /people/ringeval/usr
! endif
! 
! ifeq ($(ext),Lin)
! F90C=ifort
! FFLAGS= -O -openmp -fpp
! WMAPFLAGS= -O -save -fpp
! LAPACKL = -lmkl -lmkl_lapack
! INCLUDE = -I../camb 
! CFITSIODIR = /opt/intel/cfitsio-3.006
! HEALPIXDIR = /opt/intel/healpix-2.0.1
! endif 
! 
! ifeq ($(ext),OSF)
! F90C=f90
! FFLAGS= -omp -O -arch host -math_library fast -tune host -fpe1
! WMAPFLAGS= $(FFLAGS)
! LAPACKL  = -lcxml
! INCLUDE = -I../camb 
! endif
  
! ifeq ($(ext),Sun)
! F90C=f90
! FFLAGS= -O4 -xarch=native64 -openmp -ftrap=%none
! WMAPFLAGS= $(FFLAGS)
! LAPACKL = -lsunperf -lfsu
! INCLUDE = -I../camb -M../camb
! endif
! 
! ifeq ($(ext),AIX)
! F90C    = mpxlf90_r
! FFLAGS  = -O4 -WF,-DIBMXL,-DMPI -qstrict -qsmp=omp -qmaxmem=-1 -qsuffix=f=f90:cpp=F90
! WMAPFLAGS= $(FFLAGS)
! INCLUDE = -I../camb -lessl
! LAPACKL =
! endif
  
+ WMAPDIR = ../WMAP
  PROPOSE = propose.o
  CLSFILE = CMB_Cls_simple.o
  
  #Can use params_H if you prefer more generic parameters
  PARAMETERIZATION = params_CMB.o
  
! WMAPINCLUDE =  -I$(CFITSIODIR)/include -I$(HEALPIXDIR)/include
! # -I$(WMAPDIR)
  
! CLSLIB  = -L$(HEALPIXDIR)/lib -L$(CFITSIODIR)/lib \
! 	-L../camb -lcamb -lhealpix -lcfitsio $(LAPACKL)
  
! F90FLAGS = $(FFLAGS) $(INCLUDE)
  
  DISTFILES = utils.o settings.o GetDist.o
  
! WMAPOBJS = read_archive_map.o read_fits.o WMAP_3yr_options.o WMAP_3yr_util.o \
! 	WMAP_3yr_tt_pixlike.o WMAP_3yr_tt_beam_and_ptsrc_corr.o \
! 	WMAP_3yr_teeebb_pixlike.o WMAP_3yr_likelihood.o
  
  OBJFILES= $(WMAPOBJS) utils.o settings.o cmbtypes.o cmbdata.o WeakLen.o twodf.o mpk.o \
! 	supernovae.o lya.o\
  	$(CLSFILE) paramdef.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
  	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
  
! default: cosmomc.$(ext)
  
! all : cosmomc.$(ext) getdist.$(ext)
  
  .f.o:
  	f77 $(F90FLAGS) -c $<
  
+ %.o: $(WMAPDIR)/%.f90
+ 	$(F90C) $(WMAPFLAGS) $(WMAPINCLUDE) -c $<
+ 
  %.o: %.f90
! 	$(F90C) $(F90FLAGS) -c $<
  
  %.o: %.F90
! 	$(F90C) $(F90FLAGS) -c $<
  
  
+ cosmomc.$(ext): $(OBJFILES) 	
+ 	$(F90C) -o ../$@ $(OBJFILES) $(CLSLIB) $(F90FLAGS)
  
  clean:
  	rm -f *.o *.mod *.d *.pc *.obj ../core
  
! getdist.$(ext): $(DISTFILES)
! 	$(F90C) -o ../$@ $(DISTFILES) $(CLSLIB) $(F90FLAGS) 
diff -r -N -c -b -B cosmomc/source/Makefile.orig cosmomc_addon/source/Makefile.orig
*** cosmomc/source/Makefile.orig	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/Makefile.orig	2006-04-04 10:34:22.000000000 +0100
***************
*** 0 ****
--- 1,160 ----
+ #Settings here are for Intel ifort on CITA cluster; uncomment others below
+ #You may need to edit the library paths for MKL for Intel
+ #Beware of using optmizations which lose accuracy - may give errors when running
+ #With Visual Fortan open cosmomc.dsw workspace file instead.
+ 
+ #Edit for CFITSIO, HEALPIX directories
+ cfitsio = /home/pascal/include/cfitsio
+ healpix = /home/pascal/include/Healpix_2.00
+ WMAP3 = /home/antlewis/WMAP3
+ 
+ #Intel MPI (assuming mpif77 set to point to ifc)
+ #change -lmkl_ia32 to -lmkl_p3 for MKL versions earlier than 6 (6 needed for ifc 8+) 
+ F90C     = mpif77
+ FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp -DMPI
+ LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
+ INCLUDE = -I../camb 
+ 
+ # Use with Intel 9 on the Altix (eg. COSMOS)
+ # (do "module load icomp90" before compiling, or add to .bashrc)
+ #F90C = ifort
+ #FFLAGS = -O3 -w -fpp2 -DMPI 
+ #LAPACKL = -lscs -lguide -lmpi -ldl
+ #INCLUDE = -I../camb
+ 
+ #Intel fortran 8, check you have the latest update from the Intel web pages
+ #See Makefile_intel for ifc 7.1 or lower (some versions have problems)
+ #F90C     = ifort
+ #FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp
+ #LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
+ #INCLUDE = -I../camb 
+ 
+ #Intel fortran 8 on COSMOS
+ #F90C     = ifort
+ #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp2 -lmpi -lscs  -ldl -DMPI
+ #LAPACKL = -L/opt/intel/mkl80/lib/64 -lmkl_lapack -lmkl_ipf -limf
+ #INCLUDE = -I../camb
+ 
+ #SGI, -mp toggles multi-processor. Use -O2 if -Ofast gives problems.
+ #Not various versions of the compiler are buggy giving erroneous seg faults with -mp.
+ #Version 7.3 is OK, currently version 7.4 is bugged, as are some earlier versions.
+ #F90C     = f90
+ #LAPACKL = -lcomplib.sgimath
+ #INCLUDE = -I../camb 
+ #FFLAGS  = -Ofast -mp
+ 
+ #Digital/Compaq fortran, -omp toggles multi-processor
+ #F90C    = f90
+ #FFLAGS  = -omp -O4 -arch host -math_library fast -tune host -fpe1
+ #LAPACKL  = -lcxml
+ #INCLUDE = -I../camb 
+ 
+ #Intel Itanium efc, -openmp toggles multi-processor:
+ #F90C     = efc
+ #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp
+ #LAPACKL = -L/opt/intel/mkl/lib/64 -lmkl_lapack -lmkl_ipf -lguide -lpthread -static
+ #INCLUDE = -I../camb 
+ 
+ #Intel Itanium efc MPI:
+ # mpirun -np 4 ./cosmomc params.ini
+ #F90C     = efc
+ #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp -lmpi -lscs  -ldl -DMPI
+ #LAPACKL = -L/opt/intel/mkl/lib/64 -lmkl_lapack -lmkl_ipf -limf
+ #INCLUDE = -I../camb
+ 
+ #G95; make sure LAPACK and MPI libs also compiled with g95
+ #F90C     = mpif90
+ #FFLAGS = -O2 -DMPI
+ #LAPACKL = /LAPACK/lapack_LINUX.a /LAPACK/blas_LINUX.a
+ #INCLUDE = -I../camb
+ 
+ #Absoft ProFortran, single processor, set -cpu:[type] for your local system 
+ #F90C     = f95
+ #FFLAGS = -O2 -s -cpu:athlon -lU77 -w -YEXT_NAMES="LCS" -YEXT_SFX="_" 
+ #LAPACKL =  -llapack -lblas -lg2c 
+ #INCLUDE = -I../camb -p../camb
+ 
+ #NAGF95, single processor:
+ #F90C     = f95
+ #FFLAGS = -DNAGF95 -O3
+ #LAPACKL = -llapack -lblas -lg2c
+ #INCLUDE = -I../camb 
+ 
+ #Sun, single processor:
+ #F90C     = f90
+ #FFLAGS = -O5
+ #LAPACKL = -lsunperf -lfsu
+ #INCLUDE = -I../camb -M../camb
+ 
+ #Sun MPI
+ #F90C = mpf90
+ #FFLAGS =  -O4 -openmp -ftrap=%none -dalign -DMPI
+ #LAPACKL = -lsunperf -lfsu -lmpi_mt
+ #INCLUDE = -I../camb -M../camb
+ 
+ #Sun parallel enterprise:
+ #F90C     = f95
+ #FFLAGS =  -O4 -xarch=native64 -openmp -ftrap=%none
+ #LAPACKL = -lsunperf -lfsu
+ #INCLUDE = -I../camb -M../camb
+ 
+ #IBM XL Fortran, multi-processor (run "module load lapack" then run "gmake")
+ # See also http://cosmocoffee.info/viewtopic.php?t=326
+ #F90C     = xlf90_r $(LAPACK)
+ #FFLAGS  = -WF,-DIBMXL -qsmp=omp -qsuffix=f=f90:cpp=F90 -O3 -qstrict -qarch=pwr3 -qtune=pwr3
+ #INCLUDE = -I../camb -lessl
+ #LAPACKL =
+ 
+ PROPOSE = propose.o
+ CLSFILE = CMB_Cls_simple.o
+ 
+ #Can use params_H if you prefer more generic parameters
+ PARAMETERIZATION = params_CMB.o
+ 
+ WMAP3_inc = -I$(cfitsio)/include -I$(healpix)/include -I$(WMAP3)
+ WMAP3_lib = -L$(cfitsio)/lib -L$(healpix)/lib -L$(WMAP3) \
+ 	-lhealpix -lcfitsio
+ 
+ CLSLIB  = $(WMAP3_lib) -L../camb -lcamb $(LAPACKL) 
+ 
+ F90FLAGS = $(FFLAGS) $(WMAP3_inc) $(INCLUDE)
+ 
+ DISTFILES = utils.o settings.o GetDist.o
+ 
+ WMAPOBJS = $(WMAP3)/read_archive_map.o \
+ 	$(WMAP3)/read_fits.o \
+ 	$(WMAP3)/WMAP_3yr_options.o \
+ 	$(WMAP3)/WMAP_3yr_util.o \
+ 	$(WMAP3)/WMAP_3yr_tt_pixlike.o \
+ 	$(WMAP3)/WMAP_3yr_tt_beam_and_ptsrc_corr.o \
+ 	$(WMAP3)/WMAP_3yr_teeebb_pixlike.o \
+ 	$(WMAP3)/WMAP_3yr_likelihood.o
+ 
+ OBJFILES= $(WMAPOBJS) utils.o settings.o cmbtypes.o cmbdata.o WeakLen.o twodf.o mpk.o \
+ 	supernovae.o SDSSLy-a-v3.o\
+ 	$(CLSFILE) paramdef.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
+ 	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
+ 
+ default: cosmomc
+ 
+ all : cosmomc getdist
+ 
+ .f.o:
+ 	f77 $(F90FLAGS) -c $<
+ 
+ %.o: %.f90
+ 	$(F90C) $(F90FLAGS) -c $*.f90
+ 
+ %.o: %.F90
+ 	$(F90C) $(F90FLAGS) -c $*.F90
+ 
+ 
+ cosmomc: $(OBJFILES) 	
+ 	$(F90C) -o ../cosmomc $(OBJFILES) $(CLSLIB) $(F90FLAGS)
+ 
+ 
+ clean:
+ 	rm -f *.o *.mod *.d *.pc *.obj ../core
+ 
+ getdist: $(DISTFILES)
+ 	$(F90C) -o ../getdist $(DISTFILES) $(CLSLIB) $(F90FLAGS) 
diff -r -N -c -b -B cosmomc/source/Makefile.rej cosmomc_addon/source/Makefile.rej
*** cosmomc/source/Makefile.rej	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/Makefile.rej	2006-04-04 10:34:35.000000000 +0100
***************
*** 0 ****
--- 1,265 ----
+ ***************
+ *** 1,160 ****
+ ! #Settings here are for Intel ifort on CITA cluster; uncomment others below
+ ! #You may need to edit the library paths for MKL for Intel
+ ! #Beware of using optmizations which lose accuracy - may give errors when running
+ ! #With Visual Fortan open cosmomc.dsw workspace file instead.
+ ! 
+ ! #Edit for CFITSIO, HEALPIX directories
+ ! cfitsio = /home/pascal/include/cfitsio
+ ! healpix = /home/pascal/include/Healpix_2.00
+ ! WMAP3 = /home/antlewis/WMAP3
+ ! 
+ ! #Intel MPI (assuming mpif77 set to point to ifc)
+ ! #change -lmkl_ia32 to -lmkl_p3 for MKL versions earlier than 6 (6 needed for ifc 8+) 
+ ! F90C     = mpif77
+ ! FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp -DMPI
+ ! LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
+ ! INCLUDE = -I../camb 
+   
+ ! # Use with Intel 9 on the Altix (eg. COSMOS)
+ ! # (do "module load icomp90" before compiling, or add to .bashrc)
+ ! #F90C = ifort
+ ! #FFLAGS = -O3 -w -fpp2 -DMPI 
+ ! #LAPACKL = -lscs -lguide -lmpi -ldl
+ ! #INCLUDE = -I../camb
+ ! 
+ ! #Intel fortran 8, check you have the latest update from the Intel web pages
+ ! #See Makefile_intel for ifc 7.1 or lower (some versions have problems)
+ ! #F90C     = ifort
+ ! #FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp
+ ! #LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
+ ! #INCLUDE = -I../camb 
+ ! 
+ ! #Intel fortran 8 on COSMOS
+ ! #F90C     = ifort
+ ! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp2 -lmpi -lscs  -ldl -DMPI
+ ! #LAPACKL = -L/opt/intel/mkl80/lib/64 -lmkl_lapack -lmkl_ipf -limf
+ ! #INCLUDE = -I../camb
+ ! 
+ ! #SGI, -mp toggles multi-processor. Use -O2 if -Ofast gives problems.
+ ! #Not various versions of the compiler are buggy giving erroneous seg faults with -mp.
+ ! #Version 7.3 is OK, currently version 7.4 is bugged, as are some earlier versions.
+ ! #F90C     = f90
+   #LAPACKL = -lcomplib.sgimath
+ ! #INCLUDE = -I../camb 
+ ! #FFLAGS  = -Ofast -mp
+   
+ ! #Digital/Compaq fortran, -omp toggles multi-processor
+ ! #F90C    = f90
+ ! #FFLAGS  = -omp -O4 -arch host -math_library fast -tune host -fpe1
+ ! #LAPACKL  = -lcxml
+ ! #INCLUDE = -I../camb 
+ ! 
+ ! #Intel Itanium efc, -openmp toggles multi-processor:
+ ! #F90C     = efc
+ ! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp
+ ! #LAPACKL = -L/opt/intel/mkl/lib/64 -lmkl_lapack -lmkl_ipf -lguide -lpthread -static
+ ! #INCLUDE = -I../camb 
+ ! 
+ ! #Intel Itanium efc MPI:
+ ! # mpirun -np 4 ./cosmomc params.ini
+ ! #F90C     = efc
+ ! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp -lmpi -lscs  -ldl -DMPI
+ ! #LAPACKL = -L/opt/intel/mkl/lib/64 -lmkl_lapack -lmkl_ipf -limf
+ ! #INCLUDE = -I../camb
+ ! 
+ ! #G95; make sure LAPACK and MPI libs also compiled with g95
+ ! #F90C     = mpif90
+ ! #FFLAGS = -O2 -DMPI
+ ! #LAPACKL = /LAPACK/lapack_LINUX.a /LAPACK/blas_LINUX.a
+ ! #INCLUDE = -I../camb
+ ! 
+ ! #Absoft ProFortran, single processor, set -cpu:[type] for your local system 
+ ! #F90C     = f95
+ ! #FFLAGS = -O2 -s -cpu:athlon -lU77 -w -YEXT_NAMES="LCS" -YEXT_SFX="_" 
+ ! #LAPACKL =  -llapack -lblas -lg2c 
+ ! #INCLUDE = -I../camb -p../camb
+ ! 
+ ! #NAGF95, single processor:
+ ! #F90C     = f95
+ ! #FFLAGS = -DNAGF95 -O3
+ ! #LAPACKL = -llapack -lblas -lg2c
+ ! #INCLUDE = -I../camb 
+ ! 
+ ! #Sun, single processor:
+ ! #F90C     = f90
+ ! #FFLAGS = -O5
+ ! #LAPACKL = -lsunperf -lfsu
+ ! #INCLUDE = -I../camb -M../camb
+ ! 
+ ! #Sun MPI
+ ! #F90C = mpf90
+ ! #FFLAGS =  -O4 -openmp -ftrap=%none -dalign -DMPI
+ ! #LAPACKL = -lsunperf -lfsu -lmpi_mt
+ ! #INCLUDE = -I../camb -M../camb
+ ! 
+ ! #Sun parallel enterprise:
+ ! #F90C     = f95
+ ! #FFLAGS =  -O4 -xarch=native64 -openmp -ftrap=%none
+ ! #LAPACKL = -lsunperf -lfsu
+ ! #INCLUDE = -I../camb -M../camb
+ ! 
+ ! #IBM XL Fortran, multi-processor (run "module load lapack" then run "gmake")
+ ! # See also http://cosmocoffee.info/viewtopic.php?t=326
+ ! #F90C     = xlf90_r $(LAPACK)
+ ! #FFLAGS  = -WF,-DIBMXL -qsmp=omp -qsuffix=f=f90:cpp=F90 -O3 -qstrict -qarch=pwr3 -qtune=pwr3
+ ! #INCLUDE = -I../camb -lessl
+ ! #LAPACKL =
+   
+   PROPOSE = propose.o
+   CLSFILE = CMB_Cls_simple.o
+   
+   #Can use params_H if you prefer more generic parameters
+   PARAMETERIZATION = params_CMB.o
+   
+ ! WMAP3_inc = -I$(cfitsio)/include -I$(healpix)/include -I$(WMAP3)
+ ! WMAP3_lib = -L$(cfitsio)/lib -L$(healpix)/lib -L$(WMAP3) \
+ ! 	-lhealpix -lcfitsio
+   
+ ! CLSLIB  = $(WMAP3_lib) -L../camb -lcamb $(LAPACKL) 
+   
+ ! F90FLAGS = $(FFLAGS) $(WMAP3_inc) $(INCLUDE)
+   
+   DISTFILES = utils.o settings.o GetDist.o
+   
+ ! WMAPOBJS = $(WMAP3)/read_archive_map.o \
+ ! 	$(WMAP3)/read_fits.o \
+ ! 	$(WMAP3)/WMAP_3yr_options.o \
+ ! 	$(WMAP3)/WMAP_3yr_util.o \
+ ! 	$(WMAP3)/WMAP_3yr_tt_pixlike.o \
+ ! 	$(WMAP3)/WMAP_3yr_tt_beam_and_ptsrc_corr.o \
+ ! 	$(WMAP3)/WMAP_3yr_teeebb_pixlike.o \
+ ! 	$(WMAP3)/WMAP_3yr_likelihood.o
+   
+   OBJFILES= $(WMAPOBJS) utils.o settings.o cmbtypes.o cmbdata.o WeakLen.o twodf.o mpk.o \
+   	supernovae.o lya.o\
+   	$(CLSFILE) paramdef.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
+   	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
+   
+ ! default: cosmomc
+   
+ ! all : cosmomc getdist
+   
+   .f.o:
+   	f77 $(F90FLAGS) -c $<
+   
+   %.o: %.f90
+ ! 	$(F90C) $(F90FLAGS) -c $*.f90
+   
+   %.o: %.F90
+ ! 	$(F90C) $(F90FLAGS) -c $*.F90
+ ! 
+   
+ - cosmomc: $(OBJFILES) 	
+ - 	$(F90C) -o ../cosmomc $(OBJFILES) $(CLSLIB) $(F90FLAGS)
+   
+   
+   clean:
+   	rm -f *.o *.mod *.d *.pc *.obj ../core
+   
+ ! getdist: $(DISTFILES)
+ ! 	$(F90C) -o ../getdist $(DISTFILES) $(CLSLIB) $(F90FLAGS) 
+ --- 1,102 ----
+ ! # >>> DESIGNED FOR GMAKE <<<
+ ! 
+ ! # Unified Systems makefile for COSMOMC
+ ! # Add FLAGS -DMPI for using MPI
+   
+ ! ext=$(shell uname | cut -c1-3)
+ ! 
+ ! ifeq ($(ext),IRI)
+ ! F90C= f90
+ ! FFLAGS= -Ofast -mp -n32 -LANG:recursive=ON -lmpi -DMPI
+ ! WMAPFLAGS= $(FFLAGS)
+   #LAPACKL = -lcomplib.sgimath
+ ! LAPACKL = -lcomplib.sgimath_mp
+ ! INCLUDE = -I../camb
+ ! CFITSIODIR = /people/ringeval/usr
+ ! HEALPIXDIR = /people/ringeval/usr
+ ! endif
+ ! 
+ ! ifeq ($(ext),Lin)
+ ! F90C=ifort
+ ! FFLAGS= -O -openmp -fpp
+ ! WMAPFLAGS= -O -save -fpp
+ ! LAPACKL = -lmkl -lmkl_lapack
+ ! INCLUDE = -I../camb 
+ ! CFITSIODIR = /opt/intel/cfitsio-3.006
+ ! HEALPIXDIR = /opt/intel/healpix-2.0.1
+ ! endif 
+ ! 
+ ! ifeq ($(ext),OSF)
+ ! F90C=f90
+ ! FFLAGS= -omp -O -arch host -math_library fast -tune host -fpe1
+ ! WMAPFLAGS= $(FFLAGS)
+ ! LAPACKL  = -lcxml
+ ! INCLUDE = -I../camb 
+ ! endif
+   
+ ! ifeq ($(ext),Sun)
+ ! F90C=f90
+ ! FFLAGS= -O4 -xarch=native64 -openmp -ftrap=%none
+ ! WMAPFLAGS= $(FFLAGS)
+ ! LAPACKL = -lsunperf -lfsu
+ ! INCLUDE = -I../camb -M../camb
+ ! endif
+ ! 
+ ! ifeq ($(ext),AIX)
+ ! F90C    = mpxlf90_r
+ ! FFLAGS  = -O4 -WF,-DIBMXL,-DMPI -qstrict -qsmp=omp -qmaxmem=-1 -qsuffix=f=f90:cpp=F90
+ ! WMAPFLAGS= $(FFLAGS)
+ ! INCLUDE = -I../camb -lessl
+ ! LAPACKL =
+ ! endif
+   
+ + WMAPDIR = ../WMAP
+   PROPOSE = propose.o
+   CLSFILE = CMB_Cls_simple.o
+   
+   #Can use params_H if you prefer more generic parameters
+   PARAMETERIZATION = params_CMB.o
+   
+ ! WMAPINCLUDE =  -I$(CFITSIODIR)/include -I$(HEALPIXDIR)/include -I$(WMAPDIR)
+   
+ ! CLSLIB  = -L$(HEALPIXDIR)/lib -L$(CFITSIODIR)/lib \
+ ! 	-L../camb -lcamb -lhealpix -lcfitsio $(LAPACKL)
+   
+ ! F90FLAGS = $(FFLAGS) $(INCLUDE)
+   
+   DISTFILES = utils.o settings.o GetDist.o
+   
+ ! WMAPOBJS = read_archive_map.o read_fits.o WMAP_3yr_options.o WMAP_3yr_util.o \
+ ! 	WMAP_3yr_tt_pixlike.o WMAP_3yr_tt_beam_and_ptsrc_corr.o \
+ ! 	WMAP_3yr_teeebb_pixlike.o WMAP_3yr_likelihood.o
+   
+   OBJFILES= $(WMAPOBJS) utils.o settings.o cmbtypes.o cmbdata.o WeakLen.o twodf.o mpk.o \
+   	supernovae.o lya.o\
+   	$(CLSFILE) paramdef.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
+   	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
+   
+ ! default: cosmomc.$(ext)
+   
+ ! all : cosmomc.$(ext) getdist.$(ext)
+   
+   .f.o:
+   	f77 $(F90FLAGS) -c $<
+   
+ + %.o: $(WMAPDIR)/%.f90
+ + 	$(F90C) $(WMAPFLAGS) $(WMAPINCLUDE) -c $<
+ + 
+   %.o: %.f90
+ ! 	$(F90C) $(F90FLAGS) -c $<
+   
+   %.o: %.F90
+ ! 	$(F90C) $(F90FLAGS) -c $<
+   
+   
+ + cosmomc.$(ext): $(OBJFILES) 	
+ + 	$(F90C) -o ../$@ $(OBJFILES) $(CLSLIB) $(F90FLAGS)
+   
+   clean:
+   	rm -f *.o *.mod *.d *.pc *.obj ../core
+   
+ ! getdist.$(ext): $(DISTFILES)
+ ! 	$(F90C) -o ../$@ $(DISTFILES) $(CLSLIB) $(F90FLAGS) 
diff -r -N -c -b -B cosmomc/source/MCMC.f90 cosmomc_addon/source/MCMC.f90
*** cosmomc/source/MCMC.f90	2006-03-17 16:18:11.000000000 +0000
--- cosmomc_addon/source/MCMC.f90	2006-04-04 10:34:35.000000000 +0100
***************
*** 313,320 ****
      end if
  
      Like = GetLogLike(Trial) 
!     if (Feedback > 1) write (*,*) 'Likelihood: ', Like, 'Current Like:', CurLike
! 
      accpt = (Like /= logZero) .and. (CurLike > Like .or. randexp1() > Like - CurLike) 
               !Include the min() so that compilers not doing optimal compilation don't complain
   
--- 313,322 ----
      end if
  
      Like = GetLogLike(Trial) 
! !addon    if (Feedback > 1) write (*,*) 'Likelihood: ', Like, 'Current Like:', CurLike
!         if (Feedback > 1) write (*,*) 'Likelihood: ', Like, 'Current Like:'&
!              , CurLike, 'Rank', MPIRank
! !end addon
      accpt = (Like /= logZero) .and. (CurLike > Like .or. randexp1() > Like - CurLike) 
               !Include the min() so that compilers not doing optimal compilation don't complain
   
diff -r -N -c -b -B cosmomc/source/settings.f90 cosmomc_addon/source/settings.f90
*** cosmomc/source/settings.f90	2006-03-17 16:18:11.000000000 +0000
--- cosmomc_addon/source/settings.f90	2006-04-04 10:34:35.000000000 +0100
***************
*** 5,10 ****
--- 5,15 ----
    implicit none
  
    real :: AccuracyLevel = 1.
+ !addon
+   real :: lAccuracyLevel = 1.
+   real :: lSampleLevel = 1.
+   logical :: CambComputeEveryl = .false.
+ !end addon
    !Set to >1 to use CAMB etc on higher accuracy settings. 
    !Does not affect MCMC (except making it all slower)
  
***************
*** 43,48 ****
--- 48,56 ----
  
    integer :: num_threads = 0
    integer :: instance = 0
+ !addon
+   integer :: instance_shift = 0
+ !end addon
    integer :: MPIchains = 1, MPIrank = 0
  
    logical :: Use_LSS = .true.
